with Text_Io;
use Text_Io;

package body Demo1_Frame_Package is

   procedure Initialize (V : in out Demo1_Frame) is
      Callptr      : Callback_Button_Ptr;
   begin
      Initialize(Xv_Frame(V));

      V.Panel_Ptr  := new Xv_Panel(Get_Frame(Xv_Frame(V)),True);
      V.Button_Ptr := new Xv_Panel_Button(Get_Panel(V.Panel_Ptr.all));

      Set_Title(Xv_Frame(V),"Hello World");
      Set_Pos(Xv_Frame(V),100,100);
      Set_Size(Xv_Frame(V),200,100);
      Set_Max_Size(Xv_Frame(V),300,200);
      Set_Min_Size(Xv_Frame(V),100,100);

      Set_Text(V.Button_Ptr.all,"Quit");
      Callptr := Quit_Func'access;
      Set_Callback(V.Button_Ptr.all,Callptr);

-- Ok, here we go...
      Window_Loop(Xv_Frame(V));
   end Initialize;

   procedure Finalize (V : in out Demo1_Frame) is
   begin
      Finalize(Xv_Frame(V));
   end Finalize;

   procedure Quit_Func(Item : Panel_item; Event : Integer) is
   begin 
      raise QUIT_PROGRAM;
   end Quit_Func;
end Demo1_Frame_Package;
